#
#
"""
Workflow for Online Community Survey types
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Permissions import *

def setup_surveyFieldWorkflow(wf):
	"..."
	wf.setProperties(title='Survey Field Workflow [OCWorkflows]')

	for s in ['basic']:
		wf.states.addState(s)

	for p in (EDIT_CONTENT_PERMISSION,
			  VIEW_CONTENT_PERMISSION,
			  VIEW_RESULTS,
			  ACCESS_CONTENTS,
			  TAKE_SURVEY):
		wf.addManagedPermission(p)
		
	## Initial State
	wf.states.setInitialState('basic')
	
	## State Variable
	wf.variables.setStateVar('review_state')

	## States initialization	
	sdef = wf.states['basic']
	sdef.setProperties(title="Basic")
	sdef.setPermission(EDIT_CONTENT_PERMISSION, 1,[])
	sdef.setPermission(VIEW_CONTENT_PERMISSION, 1, [])
	sdef.setPermission(ACCESS_CONTENTS, 1, [])
	sdef.setPermission(VIEW_RESULTS, 1, [])
	sdef.setPermission(TAKE_SURVEY, 1, [])
	
		
def create_surveyFieldWorkflow(id):
	"..."
	ob = DCWorkflowDefinition(id)
	setup_surveyFieldWorkflow(ob)
	return ob

survey_field_workflow_id='survey_field_workflow'
survey_field_workflow='survey_field_workflow (Survey Field Workflow [Survey])'

addWorkflowFactory(create_surveyFieldWorkflow,
				   id='survey_field_workflow',
				   title='Survey Field Workflow [Survey]')	