from Products.Formulator.DummyField import fields
from Products.Formulator.Widget import *

class SurveyWidget:
	property_names = ['title', 'description','hidden','css_class', 'extra']

	hidden = fields.StringField('hidden', title='Hidden', description='dummy',
								hidden=1)
	css_class = fields.StringField('css_class', title='CSS class', description='dummy',
								hidden=1)
	extra = fields.StringField('extra', title='Extra', description='dummy',
								hidden=1)
									
	title = fields.StringField('title',
                               title='Title',
                               description=(
        "The title of this question. This will appear as a heading. It is required."),
                               default="",
                               required=1)

	description = fields.TextAreaField('description',
                                       title='Description',
                                       description=(
        """Description of this question.  Use this space to ask your question or
		 state your choices."""),
                                       default="",
                                       width="20", height="3",
                                       required=0)

class SurveyItemsWidget( SurveyWidget ):
	property_names = SurveyWidget.property_names + ['items', 'first_item','extra_item']
	
	first_item = fields.StringField('first_item', title='First Item', 
		description='dummy', hidden=1)
	extra_item = fields.StringField('extra_item', title='extra Item', 
		description='dummy', hidden=1)

	items = fields.ListTextAreaField('items',
                                     title='Options',
                                     description=(
        "Options for the field. Each row should list one option."
        "If you want to save one value and display another one, "
        "use the | character to separate the two on a single line."),
                                     default=[],
                                     width=20,
                                     height=5,
                                     required=0)



class SurveyTextWidget ( SurveyWidget, TextWidget ):
	property_names = SurveyWidget.property_names + ['display_width','display_maxwidth']	
	display_width = fields.StringField('display_width', title='Hidden', 
		description='dummy',hidden=1)
	display_maxwidth = fields.StringField('display_maxwidth', title='Hidden', 
		description='dummy',hidden=1)
	
SurveyTextWidgetInstance = SurveyTextWidget()
	
class SurveyCheckBoxWidget ( SurveyItemsWidget, CheckBoxWidget ):
	pass

SurveyCheckBoxWidgetInstance = SurveyCheckBoxWidget()

class SurveyTextAreaWidget ( SurveyWidget, TextAreaWidget ):
	property_names = SurveyWidget.property_names + ['width','height']
	width = fields.StringField('width', title='Hidden', 
		description='dummy',hidden=1)
	height = fields.StringField('height', title='Hidden', 
		description='dummy',hidden=1)

SurveyTextAreaWidgetInstance = SurveyTextAreaWidget()	
	
class SurveyLinesTextAreaWidget(SurveyWidget, LinesTextAreaWidget):
	pass
	
SurveyLinesTextAreaWidgetInstance = SurveyLinesTextAreaWidget()

class SurveyRadioWidget(SurveyItemsWidget, RadioWidget):
	property_names = SurveyItemsWidget.property_names + ['orientation']
	orientation = fields.StringField('orientation', title='Orientation', 
		description='dummy', hidden=1)

SurveyRadioWidgetInstance = SurveyRadioWidget()

class SurveyMultiCheckBoxWidget(SurveyItemsWidget, RadioWidget):
	property_names = SurveyItemsWidget.property_names +\
		['orientation', 'view_seperator']
	orientation = fields.StringField('orientation', title='Orientation', 
		description='dummy', hidden=1)
	view_seperator = fields.StringField('view_seperator', title='View Seperator', 
		description='dummy', hidden=1)

SurveyMultiCheckBoxWidgetInstance = SurveyMultiCheckBoxWidget()	

class SurveyDateTimeWidget(SurveyWidget, DateTimeWidget):
	pass
SurveyDateTimeWidgetInstance = SurveyDateTimeWidget()	