from Products.Archetypes.public import Schema
from Products.Archetypes.public import StringField, LinesField, BooleanField, IntegerField
from Products.Archetypes.public import IdWidget, StringWidget,LinesWidget, TextAreaWidget, BooleanWidget, IntegerWidget

#BaseSurveyFieldSchema serves all fields.
#
#Fields in the "widget" fieldset are properties of the widget.
#Fields in the "field" fieldset are properties of the field.
BaseSurveyFieldSchema = Schema((
	StringField('id',
				buildingBlockFor='widget',
				required=1,
				mode="r",
				default=None,
				widget=IdWidget(
					label="Short Name",
					label_msgid="label_short_name",
					description=("Should not contain spaces, underscores or mixed case. "
								 "Short Name is part of the item's web address."),
					description_msgid="help_shortname",
					visible={'view' : 'invisible'},
					i18n_domain="plone"),
				),
	StringField('label',
				buildingBlockFor ='widget',
				required=1,
				isImportant=1,
				default=None,
				widget=StringWidget(
					label="Label",
					label_msgid="label_title",
					description=("The label will appear in bold over the question."),
					description_msgid="help_title",
					i18n_domain="plone"),
				),
	StringField('description',
				buildingBlockFor ='widget',
				isImportant = 1,
				default='',
				widget=TextAreaWidget(
					label="Description",
					label_msgid="label_description",
					description=("Use this space to ask your question."),
					description_msgid="help_description",
				),
		),
	BooleanField('required',
				buildingBlockFor='field',
				required=0,
				isImportant=1,
				default=False,
				widget=BooleanWidget(
					label="Required",
					label_msgid="label_short_name",
					description=("Is this field required?"),
					description_msgid="help_shortname",
					i18n_domain="plone"),
				),
	))

LabelSchema = BaseSurveyFieldSchema.copy()
del(LabelSchema['required'])

BaseSurveyItemsFieldSchema = BaseSurveyFieldSchema + Schema((
	LinesField('vocabulary',
				buildingBlockFor = 'field',
				required=1,
				isImportant=1,
				default=[],
				widget=LinesWidget(
					label="Items",
					label_msgid="label_items",
					description=("List what options are available, one per line."),
					description_msgid="help_items",
				)
	),
	))